const {Router} = require("express");

module.exports = (parentRouter, path, modifiable, bodyName, save) => {
    const router = Router();
    
    router.get("/", (req, res) => res.json(req.listData));
    router.get("/list", (req, res) => res.json(!Array.isArray(req.listData) ? Object.keys(req.listData) : req.listData));
    router.get('/random', (req, res) => res.json(!Array.isArray(req.listData) ? Object.keys(req.listData)[Math.floor(Math.random() * Object.keys(req.listData).length)] : req.listData[Math.floor(Math.random() * req.listData.length)]));
    //TODO search
    
    if (modifiable) { //TODO auth
        const add = async (req, res) => {
            if (!req.body[bodyName]) {return res.status(400).send(`Missing body param "${bodyName}".`);}
            req.listData.push(req.body[bodyName]);
            return await save(req, res, req.listData, req.body[bodyName]) || res.json(req.listData);
        }
        router.post('/add', add);
        router.post('/', add);
        router.post('/clear', async (req, res) => {
            req.listData = [];
            return await save(req, res, req.listData) || res.json(req.listData);
        });
        router.delete('/remove', async (req, res) => {
            if (!req.body[bodyName]) {return res.status(400).send(`Missing body param "${bodyName}".`);}
            let index = req.listData.indexOf(req.body[bodyName]);
            if (index === -1) {return res.status(400).send("The server was unable to find an item matching the specified criteria.");}
            let length = req.listData.length;
            req.listData = req.listData.length === 1 && req.listData[0] === req.body[bodyName] ? [] : req.listData.splice(req.listData.indexOf(req.body[bodyName]), 1);
            return req.listData.length === length ? res.status(500).send("For some reason, that couldn't be removed.") : await save(req, res, req.listData) || res.json(req.listData);
        });
    }

    router.location = path;

    return router;
};