const fs = require('fs');

module.exports = app => {
    app.db.models = {ani: {}, bot: {}};
    fs.readdirSync('../db/ani').filter(file => file.endsWith('.js')).forEach(file => {
        const model = require(`./ani/${file}`)(app.db.ani);
        app.db.models.ani[model.modelName] = model;
    });
    console.log(`Built ${Object.keys(app.db.models.ani).length} models\n`);
};